//
//  STFPopUpButtonCell.m
//  SearchTextField
//
//  Created by Prachi Gauriar on Wed Mar 26 2003.
//  Copyright (c) 2003 Prachi Gauriar. All rights reserved.
//

#import "STFPopUpButtonCell.h"

@interface STFPopUpButtonCell(PrivateMethods)
- (void)_searchTextFieldPopUpCellButtonSelectionChanged:(id)sender;
@end


@implementation STFPopUpButtonCell

- (id)initTextCell:(NSString *)stringValue pullsDown:(BOOL)pullDown
{
    [super initTextCell:stringValue pullsDown:pullDown];    
    
    return self;
}


- (void)dealloc
{
    [super dealloc];

    return;
}

- (void)addItemWithTitle:(NSString *)itemTitle
{
    NSMenuItem *aMenuItem;

    [super addItemWithTitle:itemTitle];
    aMenuItem = [self itemWithTitle:itemTitle];
    [aMenuItem setTarget:self];
    [aMenuItem setAction:@selector(_searchTextFieldPopUpCellButtonSelectionChanged:)];

    return;
}


- (void)addItemsWithTitles:(NSArray *)itemTitles
{
    NSEnumerator *itemTitleEnumerator = [itemTitles objectEnumerator];
    NSString *anItemTitle;
    NSMenuItem *aMenuItem;

    [super addItemsWithTitles:itemTitles];

    while (anItemTitle = [itemTitleEnumerator nextObject]) {
        aMenuItem = [self itemWithTitle:anItemTitle];
        [aMenuItem setTarget:self];
        [aMenuItem setAction:@selector(_searchTextFieldPopUpCellButtonSelectionChanged:)];
    }

    return;
}


- (void)insertItemWithTitle:(NSString *)itemTitle atIndex:(int)index
{
    NSMenuItem *aMenuItem;
    [super insertItemWithTitle:itemTitle atIndex:index];

    aMenuItem = [self itemWithTitle:itemTitle];
    [aMenuItem setTarget:self];
    [aMenuItem setAction:@selector(_searchTextFieldPopUpCellButtonSelectionChanged:)];

    return;
}    


- (void)selectItem:(NSMenuItem *)anItem
{
    NSMenuItem *oldItem = [self selectedItem];

    if (oldItem != nil) {
        [oldItem setState:NSOffState];
    }

    [anItem setState:NSOnState];
    [super selectItem:anItem];

    return;
}


- (void)selectItemAtIndex:(int)index
{
    if (index >= 0 && index < [self numberOfItems]) {
        NSMenuItem *oldItem = [self selectedItem];

        if (oldItem) {
            [oldItem setState:NSOffState];
        }

        [[self itemAtIndex:index] setState:NSOnState];
    }

    [super selectItemAtIndex:index];

    return;
}


- (void)selectItemWithTitle:(NSString *)title
{
    NSMenuItem *oldItem = [self selectedItem];
    NSMenuItem *newItem = [self itemWithTitle:title];

    if (oldItem) {
        [oldItem setState:NSOffState];
    }

    if (newItem) {
        [newItem setState:NSOnState];
    }

    [super selectItemWithTitle:title];

    return;
}

@end


@implementation STFPopUpButtonCell(PrivateMethods)

- (void)_searchTextFieldPopUpCellButtonSelectionChanged:(id)sender
{
    NSNotificationCenter *defaultCenter = [NSNotificationCenter defaultCenter];
    
    [defaultCenter postNotificationName:@"STFPopUpButtonCellSelectionChanged"
                                 object:self
                               userInfo:nil];

    return;
}

@end


